import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)
/**
 * This class defines a crab. Crabs live on the beach. They like sand worms 
 * (very yummy, especially the green ones).
 * 
 * Version: 2
 * 
 * In this version, the crab walks around the beach more or less randomly.
 * I changed the turn to a set number 5
 * I changed the turn to Greenfoot.getRandomNumber(45)
 * I added -45 after the getRandomNumber to make the crab turn left randomly
 * I changed the code to getRandomNumber(90)-45 to make it change left and right randomly
 * I added the code to eat the worm
 * I added the method lookForWorm()
 * I added the method randomTurn()
 * I added the method turnAtEdge()
 * I removed the randomTurn() code from the act method
 * I removed the turnAtEdge() code from the act method
 * I made the checkKeypress() method
 * I added the checkKeypress() code to the act method
 * I added teh slurp sound to play after the crab eats a worm
 * I added the image variables
 * I added values to the image variables
 * I added the switch image code to simulate movement in the crab
 * I moved the switch image code to its own method
 * I added the wormsEaten counter
 * I added the code to add one to the counter after eating a worm
 * I added the code to play a sound and stop the game when the crab eats 8 worms
 * I added the counter so that the images would switch slower
 */

public class Crab extends Animal
{
    private GreenfootImage image1;
    private GreenfootImage image2;
    private int wormsEaten;
    private int counter;
    /**
     * Create a crab and initialize its two images.
     */
    public Crab()
    {
        image1 = new GreenfootImage("crab.png");
        image2 = new GreenfootImage("crab2.png");
        setImage(image1);
        wormsEaten = 0;
        counter=0;
    }
    /** 
     * Act - do whatever the crab wants to do. This method is called whenever
     *  the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act()
    {
        checkKeypress();
        move();
        lookForWorm();
        counter();
    }
    /**
     * Check whether we have stumbled upon a worm.
     * If we have, eat it. If not, do nothing.
     */
    public void lookForWorm()
    {
        if ( canSee(Worm.class) )
        {
            eat(Worm.class);
            Greenfoot.playSound("slurp.wav");
            
            wormsEaten = wormsEaten+1;
            if(wormsEaten==8)
            {
                Greenfoot.playSound("fanfare.wav");
                Greenfoot.stop();
            }
        }
    }
    /**
     * Check whether random number is less than 10.
     * If it is, turn a random degree left or right. If not, do nothing.
     */
    public void randomTurn()
    {
        if ( Greenfoot.getRandomNumber(100) < 10 )
        {
            turn( Greenfoot.getRandomNumber(90)-45 );
        }
    }
    /**
     * Check whether we are at the world's edge.
     * If we are, turn 17 degrees right. If not, do nothing.
     */
    public void turnAtEdge()
    {
        if ( atWorldEdge() )
        {
            turn(17);
        }
    }
    /**
     * Check whether a key is pressed.
     * If left is pressed turn left.
     * If right is pressed turn right.
     */
    public void checkKeypress()
    {
        if (Greenfoot.isKeyDown("left"))
        {
            turn(-4);
        }
        if (Greenfoot.isKeyDown("right"))
        {
            turn(4);
        }
    }
    /**
     * switches the crabs images to simulate movement
     */
    public void switchImage()
    {
        if(getImage() == image1)
        {
            setImage(image2);
        }
        else
        {
            setImage(image1);
        }
    }
    /**
     * counts up to switch images slower
     */
    public void counter()
    {
        counter=counter+1;
        if(counter==3)
        {
            switchImage();
            counter=0;
        }
    }
}
